package gr.uoi.loginscreen;

import androidx.appcompat.app.AlertDialog;
import androidx.appcompat.app.AppCompatActivity;

import android.content.DialogInterface;
import android.graphics.Color;
import android.os.Bundle;
import android.text.InputType;
import android.util.DisplayMetrics;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.LinearLayout;
import android.widget.TextView;

public class MainActivity extends AppCompatActivity {



        LinearLayout mainLayout=null;
        LinearLayout header=null;
        LinearLayout editLayout=null;
        LinearLayout buttonLayout=null;
        int width=0,height=0;
        EditText usernameText,passwordText;
        Button okButton,clearButton;

        void makeHeader()
        {
            header=new LinearLayout(this);
            header.setOrientation(LinearLayout.HORIZONTAL);
            mainLayout.addView(header);
            LinearLayout.LayoutParams hparams=(LinearLayout.LayoutParams)header.getLayoutParams();
            hparams.width=width;
            hparams.height=10 * height/100;
            header.setLayoutParams(hparams);

            header.setBackgroundColor(Color.BLUE);
            TextView title=new TextView(this);
            title.setTextColor(Color.WHITE);
            title.setText("Form data");
            title.setTextSize(24);
            header.addView(title);

            LinearLayout.LayoutParams tparams=(LinearLayout.LayoutParams)title.getLayoutParams();
            tparams.width=50 * hparams.width/100;
            tparams.leftMargin=25 * hparams.width/100;
            tparams.topMargin=10 * hparams.height/100;
            tparams.height= 80 *hparams.height/100;
            title.setLayoutParams(tparams);
        }

        void makeEdit()
        {
            editLayout=new LinearLayout(this);
            editLayout.setOrientation(LinearLayout.VERTICAL);
            mainLayout.addView(editLayout);
            LinearLayout.LayoutParams eparams=(LinearLayout.LayoutParams)editLayout.getLayoutParams();
            eparams.width=width;
            eparams.height=60 * height/100;
            editLayout.setLayoutParams(eparams);
            usernameText=new EditText(this);
            usernameText.setTextSize(18);
            usernameText.setHint("Enter username");
            usernameText.setInputType(InputType.TYPE_CLASS_TEXT);
            usernameText.setPadding(20,10,10,10);
            usernameText.setBackgroundResource(R.drawable.roundedittext);
            editLayout.addView(usernameText);
            LinearLayout.LayoutParams uparams=(LinearLayout.LayoutParams)usernameText.getLayoutParams();
            uparams.leftMargin=10 * width/100;
            uparams.width=80 * width/100;
            uparams.height=10 * height/100;
            uparams.topMargin= 5 * height/100;
            usernameText.setLayoutParams(uparams);

            passwordText=new EditText(this);
            passwordText.setTextSize(18);
            passwordText.setHint("Enter password");
            passwordText.setInputType(InputType.TYPE_CLASS_TEXT |
                    InputType.TYPE_TEXT_VARIATION_PASSWORD);
            passwordText.setPadding(10,10,10,10);
            passwordText.setBackgroundResource(R.drawable.roundedittext);
            editLayout.addView(passwordText);
            passwordText.setLayoutParams(uparams);
        }

        void makeButtons()
        {
            buttonLayout=new LinearLayout(this);
            buttonLayout.setOrientation(LinearLayout.HORIZONTAL);
            mainLayout.addView(buttonLayout);
            LinearLayout.LayoutParams bparams=(LinearLayout.LayoutParams)buttonLayout.getLayoutParams();
            bparams.width=width;
            bparams.height=20 * height/100;
            buttonLayout.setLayoutParams(bparams);

            clearButton=new Button(this);
            clearButton.setText("CLEAR");
            buttonLayout.addView(clearButton);
            LinearLayout.LayoutParams cparams=(LinearLayout.LayoutParams)clearButton.getLayoutParams();
            cparams.leftMargin=5 * width/100;
            cparams.topMargin= 2 * height/100;
            cparams.width=40 * width/100;
            clearButton.setLayoutParams(cparams);
            clearButton.setOnClickListener(new View.OnClickListener() {
                @Override
                public void onClick(View v) {
                    usernameText.setText("");
                    passwordText.setText("");
                }
            });

            okButton=new Button(this);
            okButton.setText("OK");
            buttonLayout.addView(okButton);
            okButton.setLayoutParams(cparams);
            okButton.setOnClickListener(new View.OnClickListener() {
                @Override
                public void onClick(View v) {
                    showAlert("Details are "+usernameText.getText().toString()+" "+passwordText.getText().toString());
                }
            });
        }

        public void showAlert(String message)
        {
            AlertDialog.Builder alertDialogBuilder = new AlertDialog.Builder(this);

            alertDialogBuilder.setTitle(getString(R.string.app_name));

            alertDialogBuilder
                    .setMessage(message)
                    .setCancelable(false)
                    .setPositiveButton("OK",new DialogInterface.OnClickListener() {
                        public void onClick(DialogInterface dialog,int id) {
                            dialog.cancel();
                        }
                    });
            AlertDialog alertDialog = alertDialogBuilder.create();
            alertDialog.show();
        }

        void getDimensions()
        {
            DisplayMetrics metrics = new DisplayMetrics();
            getWindowManager().getDefaultDisplay().getMetrics(metrics);
            height = metrics.heightPixels;
            width = metrics.widthPixels;
        }

        @Override
        protected void onCreate(Bundle savedInstanceState) {
            super.onCreate(savedInstanceState);
            mainLayout=new LinearLayout(this);
            mainLayout.setBackgroundColor(Color.GRAY);
            mainLayout.setOrientation(LinearLayout.VERTICAL);

            setContentView(mainLayout);
            getDimensions();
            makeHeader();
            makeEdit();
            makeButtons();
        }
    }
